//
//  ANImageHelper-Heightmap.h
//  AvisNocturnaCrossCore
//
//  Created by Mendel Kucharzeck on 31.12.11.
//  Copyright 2011 AvisNocturna Software. All rights reserved.
//

#import "ANImageHelper.h"

@interface ANImageHelper (Heightmap)

+ (float*) heightmapFromMaskImage:(CGImageRef)mask andLargestValue:(float*)largestValue;
+ (float*) invertedHeightmapFromMaskImage:(CGImageRef)mask andLargestValue:(float*)largestValue;

+ (void) addBumpsToHeight:(float*)heightmap inMask:(CGImageRef)mask withStrength:(float)strength andSize:(float)size;
+ (void) addWavesToHeight:(float*)heightmap inMask:(CGImageRef)mask withStrength:(float)strength andSize:(float)size;
+ (void) addRasterToHeight:(float*)heightmap inMask:(CGImageRef)mask withStrength:(float)strength andSize:(float)size;

//FOR DEBUG
+ (CGImageRef) convertHeightmapToImageRef:(float*)heightmap withMask:(CGImageRef)mask andLargestValue:(float)largestValue andSmoothFactor:(float)smoothFactor;
+ (CGImageRef) convertHeightmapToNormalImageRef:(float*)heightmap withMask:(CGImageRef)mask andLargestValue:(float)largestValue  andSmoothFactor:(float)smoothFactor;

@end
