//
//  LCTextBoxObject.h
//  LogoistCore
//
//  Created by Mendel Kucharzeck on 02.06.12.
//  Copyright (c) 2012 AvisNocturna Software. All rights reserved.
//

#import "LCFrameObject.h"
#import <AvisNocturnaCrossCore/ANTextDrawingHelper.h>
#import <AvisNocturnaCrossCore/ANGeometryHelper-Defines.h>

@interface LCTextBoxObject : LCFrameObject
{
    float xStretch;
    float yStretch;
    
    float lineHeightMultiple;
    float kerning;
    
    ANGeometry_PathMode pathMode;
    float strokeLineWidth;
    
    TextDrawingHelperAlignment textAlignment;
    TextDrawingHelperAlignment verticalTextAlignment;
    
    NSString *text;
    ANPlatformFont *font;
    
    //Cache
    CGPathRef cachedPathRef;
}

@property (assign) float xStretch;
@property (assign) float yStretch;

@property (assign) float lineHeightMultiple;
@property (assign) float kerning;

@property (assign) ANGeometry_PathMode pathMode;
@property (assign) float strokeLineWidth;

@property (retain) NSString *text;
@property (retain) ANPlatformFont *font;
@property (assign) float fontSize;

@property (assign) TextDrawingHelperAlignment textAlignment;
@property (assign) TextDrawingHelperAlignment verticalTextAlignment;

@end
